require('extensions.rb')

module GKWare # Proprietary TopLevel Namespace: No Trespassing!

  module DXF # Namespace for THIS plugin
    # Create an entry in the Extension list that loads script called:
    # "gkware_cabmaker3_loader.rb"
    APP_VERSION = '1.0.4'

    @plugin = SketchupExtension.new('GKWare Simple DXF', File.join('gkware_simple_dxf', 'gkware_simple_dxf_loader'))

    @plugin.creator = 'Garry Kernan'
    @plugin.copyright = '(c)2013-2019 by GKWare'
    @plugin.version = APP_VERSION
    @plugin.description = 'Simple DXF imports / exports simple dxf files - http://www.CabMaker32.com'

    unless @plugin.class.method_defined?(:path)
      #
      # Define a singleton method for @plugin to access the @path attribute.
      # (... because the API did not do it in extensions.rb !!)
      #
      def @plugin.path()
        instance_variable_get(:@path)
      end
    end # unless

    # Create local path and filename constants:

    PATH = @plugin.path()
    LOADER_SUFFIX = '_loader'
    LOADER = File.basename(PATH)
    tmp = LOADER.split('_')
    RBSFILE = tmp[0] + '_' + tmp[1] + '.rbs'

    # RELDIR is relative to Plugins dir, OR the dir from
    # the $LOAD_PATH array that require used to find it.
    RELDIR = File.dirname(PATH)

    ROOT = $LOAD_PATH.find(false) do |abspath|
      Kernel.test(?d, File.join(abspath, RELDIR))
    end

    if ROOT
      ABSDIR = File.join(ROOT, RELDIR)
    else
      # assume the target dir is directly below, the dir that THIS file is in.
      ABSDIR = File.join(File.dirname(__FILE__), RELDIR)
    end

    # Register this extension with the Sketchup::ExtensionManager
    Sketchup.register_extension(@plugin, true)

  end # module GKWare::CabMaker3

end # module GKWare
